﻿using System;
using System.Configuration;
using System.IO; 
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

//		private FAXdeWebservice.IXMLWS2service  faxService	= new Fax_de.IXMLWS2service(); //Neues Webserviceobjekt erstellen //create new WebService Object			  

namespace FAXdeDemo
{

    public partial class FormDemo : Form
    {
        private FAXde.IntfXMLWSservice  faxService	= new FAXde.IntfXMLWSservice(); 

        public FormDemo()
        {
            InitializeComponent();
        }

        private void FormDemo_Load(object sender, EventArgs e)
        {
            textBoxAccount.Text = Properties.Settings.Default["Account"].ToString();
            textBoxPassword.Text = Properties.Settings.Default["Password"].ToString();

            comboBoxJobType.SelectedIndex = 0;
            dateTimePickerSendDate.Value = DateTime.Now;
            dateTimePickerSendTime.Value = DateTime.Now;

        }

        private void FormDemo_FormClosed(object sender, FormClosedEventArgs e)
        {
            Properties.Settings.Default["Account"] = textBoxAccount.Text;
            Properties.Settings.Default["Password"] = textBoxPassword.Text;
            Properties.Settings.Default.Save();
        }


        private string GetFilename()
        {
            OpenFileDialog ofd;
            ofd = new OpenFileDialog();
            if (ofd.ShowDialog() == DialogResult.OK)
                return ofd.FileName;
//            if (openFileDialog1.ShowDialog() == DialogResult.OK)
//                return openFileDialog1.FileName;
            else
                return "";
        }

        private byte[] LoadFile(string filename)
        {
            FileStream fs = new FileStream(filename, FileMode.Open, FileAccess.Read);
            byte[] byteArray = new byte[fs.Length];
            fs.Read(byteArray, 0, Convert.ToInt32(fs.Length));
            fs.Close();
            return byteArray;
        }

        private void SaveFile(string filename, byte[] filedata)
        {
            FileStream fs = new FileStream(filename, FileMode.Create, FileAccess.Write);
            fs.Write(filedata, 0, filedata.Length);
            fs.Close();
        }

        private void checkBoxSendNow_CheckedChanged(object sender, EventArgs e)
        {
            dateTimePickerSendDate.Enabled = !checkBoxSendNow.Checked;
            dateTimePickerSendTime.Enabled = !(checkBoxSendNow.Checked);
        }

        private void buttonRecipientFile_Click(object sender, EventArgs e)
        {
            textBoxRecipientFile.Text = GetFilename();
        }


        private void buttonSendFile1_Click(object sender, EventArgs e)
        {
            textBoxSendFile1.Text = GetFilename();
        }

        private void buttonSendFile2_Click(object sender, EventArgs e)
        {
            textBoxSendFile2.Text = GetFilename();
        }

        private void buttonSendFile3_Click(object sender, EventArgs e)
        {
            textBoxSendFile3.Text = GetFilename();
        }

        private void buttonSend_Click(object sender, EventArgs e)
        {
            int Res;
            int JobType = comboBoxJobType.SelectedIndex;
            byte[] RecipientFile = null; ;
            byte[] SendFile1 = null;
            byte[] SendFile2 = null;
            byte[] SendFile3 = null;
            DateTime SendDateTime;
            int JobId;
            int RecipientsCount=0;
            int PageCount=0;


            if (textBoxRecipientFile.Text != "")
                RecipientFile = LoadFile(textBoxRecipientFile.Text);
            if (textBoxSendFile1.Text != "")
                SendFile1 = LoadFile(textBoxSendFile1.Text);
            if (textBoxSendFile2.Text != "")
                SendFile2 = LoadFile(textBoxSendFile2.Text);
            if (textBoxSendFile3.Text != "")
                SendFile3 = LoadFile(textBoxSendFile3.Text);
            if (checkBoxSendNow.Checked)
                SendDateTime = DateTime.Now;
            else
//                SendDateTime = dateTimePickerSendDate.Value.Date;
                //SendDateTime. .TimeOfDay = dateTimePickerSendTime.Value.TimeOfDay;
                SendDateTime = ( Convert.ToDateTime( dateTimePickerSendDate.Text + " " + dateTimePickerSendTime.Text)).ToUniversalTime();


            Res = faxService.SendJob(textBoxAccount.Text,
                                        textBoxPassword.Text,
                                        JobType,
                                        textBoxRecipient.Text,
                                        RecipientFile,
                                        textBoxSendText.Text,
                                        textBoxSendFile1.Text,
                                        SendFile1,
                                        textBoxSendFile2.Text,
                                        SendFile2,
                                        textBoxSendFile3.Text,
                                        SendFile3,
                                        SendDateTime,
                                        textBoxOptions.Text,
                                        out JobId,
                                        out RecipientsCount,
                                        out PageCount);

            textBoxSendResult.Text = Res.ToString();
            textBoxSendJobId.Text = JobId.ToString();
            textBoxCancelJobId.Text = JobId.ToString();
            textBoxStatusJobId.Text = JobId.ToString();
            textBoxSendRecipientCount.Text = RecipientsCount.ToString();
            textBoxSendPageCount.Text = PageCount.ToString();

        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            int Res;
            Res = faxService. CancelJob(textBoxAccount.Text,
                                        textBoxPassword.Text,
                                        Convert.ToInt32(textBoxCancelJobId.Text));
            textBoxCancelResult.Text = Convert.ToString(Res);
        }


        private void buttonStatus_Click(object sender, EventArgs e)
        {
            int Res;
            DateTime SendDateTime;
            string SendResult;
            string RemoteId;
            byte[] StatusFile;

            Res = faxService.JobStatus(textBoxAccount.Text,
                                       textBoxPassword.Text,
                                       Convert.ToInt32(textBoxStatusJobId.Text),
                                       out SendResult,
                                       out SendDateTime,
                                       out RemoteId,
                                       out StatusFile);
            textBoxStatusResult.Text = Res.ToString();
            textBoxStatusSendResult.Text = SendResult;
            textBoxStatusSendDateTime.Text = SendDateTime.ToString();
            textBoxStatusRemoteId.Text = RemoteId;
            textBoxStatusStatusFile.Text = System.Text.Encoding.Default.GetString(StatusFile);

        }

        private void buttonReceiveRequest_Click(object sender, EventArgs e)
        {
            int Res;
            long FaxId;
            DateTime ReceiveDateTime;
            string Originator;
            string RemoteId;
            int PageCount;
            byte[] FaxImage;

            Res = faxService.RequestReceived(textBoxAccount.Text,
                                                 textBoxPassword.Text,
                                                 out FaxId,
                                                 out ReceiveDateTime,
                                                 out Originator,
                                                 out RemoteId,
                                                 out PageCount,
                                                 out FaxImage);

            textBoxReceiveRequestResult.Text = Res.ToString();
            textBoxReceiveRequestFaxId.Text = FaxId.ToString();
            textBoxReceiveDeleteFaxId.Text = FaxId.ToString();
            textBoxReceiveRequestDateTime.Text = ReceiveDateTime.ToString();
            textBoxReceiveRequestOriginator.Text = Originator;
            textBoxReceiveRequestRemoteId.Text = RemoteId;
            SaveFile(ReceiveDateTime. ToString( "yyyy-MM-dd HH-mm-ss" ) + " " + FaxId.ToString() + ".tif", FaxImage);


        }

        private void buttonReceiveDelete_Click(object sender, EventArgs e)
        {
            int Res;
            long FaxId;
            try
            {
                FaxId = Convert.ToInt64(textBoxReceiveDeleteFaxId.Text);
            }
            catch
            {
                FaxId = 0;
            }

            Res = faxService.DeleteReceived ( textBoxAccount.Text,
                                              textBoxPassword.Text,
                                              FaxId);
            textBoxReceiveDeleteResult.Text = Res.ToString();
        }
    }
}
